﻿using PizzeriaContracts.BindingModels;
using PizzeriaContracts.ViewModels;
using PizzeriaDataModels;

namespace PizzeriaListImplement.Models
{
    public class Shop : IShopModel
    {
        public int Id { get; private set; }
        public string ShopName { get; private set; } = string.Empty;
        public string Addres { get; private set; } = string.Empty;
        public DateTime OpenTime { get; private set; } = DateTime.Now;

        public Dictionary<int, (IPizzaModel, int)> ShopPizzas
        {
            get;
            private set;
        } = new Dictionary<int, (IPizzaModel, int)>();
        public static Shop? Create(ShopBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Shop()
            {

                Id = model.Id,
                ShopName = model.ShopName,
                Addres = model.Addres,
                OpenTime = model.OpenTime,
                ShopPizzas = model.ShopPizzas
            };
        }
        public void Update(ShopBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            ShopName = model.ShopName;
            Addres = model.Addres;
            OpenTime = OpenTime;
            ShopPizzas = model.ShopPizzas;
        }
        public ShopViewModel GetViewModel => new()
        {
            Id = Id,
            ShopName = ShopName,
            Addres = Addres,
            OpenTime = OpenTime,
            ShopPizzas = ShopPizzas
        };
    }
}

